X-Git-Url: https://git.madduck.net/code/vcsh.git/blobdiff_plain/65dc14e50ac4a8b19e0c27671d18cfd50b60bd8e..cb24803b0d99ba0ececdb9906ec15af24be1e381:/vcsh?ds=inline

diff --git a/vcsh b/vcsh
index ea88931..6e18e16 100755
--- a/vcsh
+++ b/vcsh
@@ -1,7 +1,7 @@
 #!/bin/sh
 
 # This program is licensed under the GNU GPL version 2 or later.
-# (c) Richard "RichiH" Hartmann <richih.mailinglist@gmail.com>, 2011-2013
+# (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2014
 # For details, see LICENSE. To submit patches, you have to agree to
 # license your code under the GNU GPL version 2 or later.
 
@@ -15,16 +15,12 @@
 # This should always be the first line of code to facilitate debugging
 [ -n "$VCSH_DEBUG" ] && set -vx
 
-basename() {
-	# Implemented in shell to avoid spawning another process
-	local file
-	file="${1##*/}"
-	[ -z "$2" ] || file="${file%$2}"
-	echo "$file"
-}
 
+# If '.git-HEAD' is appended to the version, you are seeing an unreleased
+# version of vcsh; the master branch is supposed to be clean at all times
+# so you can most likely just use it nonetheless
+VERSION='1.20140313'
 SELF=$(basename $0)
-VERSION='1.20130723'
 
 fatal() {
 	echo "$SELF: fatal: $1" >&2
@@ -38,11 +34,13 @@ while getopts "c:dv" flag; do
 	if [ "$1" = '-d' ] || [ "$1" = '--debug' ]; then
 		set -vx
 		VCSH_DEBUG=1
+		echo "debug mode on"
 		echo "$SELF $VERSION"
-	elif [ "$1" = '-v' ];then
+	elif [ "$1" = '-v' ]; then
 		VCSH_VERBOSE=1
+		echo "verbose mode on"
 		echo "$SELF $VERSION"
-	elif [ "$1" = '-c' ];then
+	elif [ "$1" = '-c' ]; then
 		VCSH_OPTION_CONFIG=$OPTARG
 	fi
 	shift 1
@@ -59,7 +57,7 @@ source_all() {
 
 # Read configuration and set defaults if anything's not set
 [ -n "$VCSH_DEBUG" ]                  && set -vx
-[ -z "$XDG_CONFIG_HOME" ]             && XDG_CONFIG_HOME="$HOME/.config"
+: ${XDG_CONFIG_HOME:=$HOME/.config}
 
 # Read configuration files if there are any
 [ -r "/etc/vcsh/config" ]             && . "/etc/vcsh/config"
@@ -75,10 +73,20 @@ fi
 [ -n "$VCSH_DEBUG" ]                  && set -vx
 
 # Read defaults
-[ -z "$VCSH_REPO_D" ]                 && VCSH_REPO_D="$XDG_CONFIG_HOME/vcsh/repo.d"
-[ -z "$VCSH_HOOK_D" ]                 && VCSH_HOOK_D="$XDG_CONFIG_HOME/vcsh/hooks-enabled"
-[ -z "$VCSH_BASE" ]                   && VCSH_BASE="$HOME"
-[ -z "$VCSH_GITIGNORE" ]              && VCSH_GITIGNORE='exact'
+: ${VCSH_REPO_D:=$XDG_CONFIG_HOME/vcsh/repo.d}
+: ${VCSH_HOOK_D:=$XDG_CONFIG_HOME/vcsh/hooks-enabled}
+: ${VCSH_BASE:=$HOME}
+: ${VCSH_GITIGNORE:=exact}
+: ${VCSH_GITATTRIBUTES:=none}
+: ${VCSH_WORKTREE:=absolute}
+
+if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
+	fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
+fi
+
+if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ] && [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
+	fatal "'\$VCSH_WORKTREE' must equal 'absolute', or 'relative'" 1
+fi
 
 
 help() {
@@ -92,6 +100,7 @@ help() {
    commands:
    clone <remote> \\
          [<repo>]       Clone from an existing repository
+   commit               Commit in all repositories
    delete <repo>        Delete an existing repository
    enter <repo>         Enter repository; spawn new instance of \$SHELL
    help                 Display this help text
@@ -106,6 +115,7 @@ help() {
           <newname>     Rename repository
    run <repo> \\
        <command>        Use this repository
+   status [<repo>]      Show statuses of all/one vcsh repositories
    upgrade <repo>       Upgrade repository to currently recommended settings
    version              Print version information
    which <substring>    Find substring in name of any tracked file
@@ -143,20 +153,35 @@ clone() {
 		exit
 	fi
 	git fetch
-	for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
+	hook pre-merge
+	git ls-tree -r --name-only origin/master | (while read object; do
 		[ -e "$object" ] &&
 			error "'$object' exists." &&
-			VCSH_CONFLICT=1;
+			VCSH_CONFLICT=1
 	done
-	[ "$VCSH_CONFLICT" = '1' ] &&
+	[ "$VCSH_CONFLICT" = '1' ]) &&
 		fatal "will stop after fetching and not try to merge!
-  Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
+  Once this situation has been resolved, run 'vcsh $VCSH_REPO_NAME pull' to finish cloning." 17
 	git merge origin/master
+	hook post-merge
 	hook post-clone
 	retire
 	hook post-clone-retired
 }
 
+commit() {
+	hook pre-commit
+	for VCSH_REPO_NAME in $(list); do
+		echo "$VCSH_REPO_NAME: "
+		export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+		use
+		git commit --untracked-files=no --quiet
+		VCSH_COMMAND_RETURN_CODE=$?
+		echo
+	done
+	hook post-commit
+}
+
 delete() {
 	cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
 	use
@@ -196,12 +221,13 @@ hook() {
 }
 
 init() {
+	hook pre-init
 	[ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
-	export GIT_WORK_TREE="$VCSH_BASE"
-	mkdir -p "$GIT_WORK_TREE" || fatal "could not create '$GIT_WORK_TREE'" 50
-	cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
-	git init
+	mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
+	cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
+	git init --shared=0600
 	upgrade
+	hook post-init
 }
 
 list() {
@@ -229,10 +255,12 @@ list_tracked_by() {
 pull() {
 	hook pre-pull
 	for VCSH_REPO_NAME in $(list); do
-		echo -n "$VCSH_REPO_NAME: "
+		printf "$VCSH_REPO_NAME: "
 		export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
 		use
 		git pull
+		VCSH_COMMAND_RETURN_CODE=$?
+		echo
 	done
 	hook post-pull
 }
@@ -240,16 +268,17 @@ pull() {
 push() {
 	hook pre-push
 	for VCSH_REPO_NAME in $(list); do
-		echo -n "$VCSH_REPO_NAME: "
+		printf "$VCSH_REPO_NAME: "
 		export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
 		use
 		git push
+		VCSH_COMMAND_RETURN_CODE=$?
+		echo
 	done
 	hook post-push
 }
 
 retire() {
-	unset GIT_WORK_TREE
 	unset VCSH_DIRECTORY
 }
 
@@ -261,7 +290,7 @@ rename() {
 	# Now that the repository has been renamed, we need to fix up its configuration
 	# Overwrite old name..
 	GIT_DIR="$GIT_DIR_NEW"
-	$VCSH_REPO_NAME="$VCSH_REPO_NAME_NEW"
+	VCSH_REPO_NAME="$VCSH_REPO_NAME_NEW"
 	# ..and clobber all old configuration
 	upgrade
 }
@@ -270,22 +299,52 @@ run() {
 	hook pre-run
 	use
 	"$@"
+	VCSH_COMMAND_RETURN_CODE=$?
 	hook post-run
 }
 
+status() {
+	if [ ! "x$VCSH_REPO_NAME" = "x" ]; then
+		export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+		use
+		git status --short --untracked-files='no'
+		VCSH_COMMAND_RETURN_CODE=$?
+	else
+		for VCSH_REPO_NAME in $(list); do
+			echo "$VCSH_REPO_NAME:"
+			export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+			use
+			git status --short --untracked-files='no'
+			VCSH_COMMAND_RETURN_CODE=$?
+			echo
+		done
+	fi
+}
+
 upgrade() {
 	hook pre-upgrade
-	use
-	git config core.worktree     "$GIT_WORK_TREE"
+	# fake-bare repositories are not bare, actually. Set this to false
+	# because otherwise Git complains "fatal: core.bare and core.worktree
+	# do not make sense"
+	git config core.bare false
+	# core.worktree may be absolute or relative to $GIT_DIR, depending on
+	# user preference
+	if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ]; then
+		git config core.worktree $(cd $GIT_DIR && GIT_WORK_TREE="$VCSH_BASE" git rev-parse --show-cdup)
+	elif [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
+		git config core.worktree "$VCSH_BASE"
+	fi
 	[ ! "x$VCSH_GITIGNORE" = 'xnone' ] && git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
-	git config vcsh.vcsh         'true'
+	[ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && git config core.attributesfile ".gitattributes.d/$VCSH_REPO_NAME"
+	git config vcsh.vcsh 'true'
+	use
 	[ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
+	[ -e "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME"
 	hook post-upgrade
 }
 
 use() {
 	git_dir_exists
-	export GIT_WORK_TREE="$(git config --get core.worktree)"
 	export VCSH_DIRECTORY="$VCSH_REPO_NAME"
 }
 
@@ -306,6 +365,8 @@ write_gitignore() {
 
 	use
 	cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
+	OLDIFS="$IFS"
+	IFS=$(printf '\n\t')
 	gitignores=$(for file in $(git ls-files); do
 		while true; do
 			echo $file; new="${file%/*}"
@@ -313,7 +374,12 @@ write_gitignore() {
 			file="$new"
 		done;
 	done | sort -u)
-	tempfile=$(mktemp) || fatal "could not create tempfile" 51
+
+	# Contrary to GNU mktemp, mktemp on BSD/OSX requires a template for temp files
+	# Using a template makes GNU mktemp default to $PWD and not #TMPDIR for tempfile location
+	# To make every OS happy, set full path explicitly
+	tempfile=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal "could not create tempfile: '${tempfile}'" 51
+
 	echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
 	for gitignore in $gitignores; do
 		echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
@@ -321,6 +387,7 @@ write_gitignore() {
 			{ echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
 		fi
 	done
+	IFS="$OLDIFS"
 	if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
 		rm -f "$tempfile" || error "could not delete '$tempfile'"
 		exit
@@ -334,47 +401,71 @@ write_gitignore() {
 		fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
 }
 
+debug $(git version)
+
 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
 	fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
 fi
 
-if [ "$1" = 'clone' ]; then
-	[ -z "$2" ] && fatal "$1: please specify a remote" 1
-	export VCSH_COMMAND="$1"
+export VCSH_COMMAND="$1"
+
+case "$VCSH_COMMAND" in
+	clon|clo|cl) VCSH_COMMAND=clone;;
+	commi|comm|com|co) VCSH_COMMAND=commit;;
+	delet|dele|del|de) VCSH_COMMAND=delete;;
+	ente|ent|en) VCSH_COMMAND=enter;;
+	hel|he) VCSH_COMMAND=help;;
+	ini|in) VCSH_COMMAND=init;;
+	pul) VCSH_COMMAND=pull;;
+	pus) VCSH_COMMAND=push;;
+	renam|rena|ren|re) VCSH_COMMAND=rename;;
+	ru) VCSH_COMMAND=run;;
+	statu|stat|sta|st) VCSH_COMMAND=status;;
+	upgrad|upgra|upgr|up) VCSH_COMMAND=upgrade;;
+	versio|versi|vers|ver|ve) VCSH_COMMAND=version;;
+	which|whi|wh) VCSH_COMMAND=which;;
+	write|writ|wri|wr) VCSH_COMMAND=write-gitignore;;
+esac    
+
+if [ "$VCSH_COMMAND" = 'clone' ]; then
+	[ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a remote" 1
 	GIT_REMOTE="$2"
-	[ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
+	[ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "${GIT_REMOTE#*:}" .git)
+	[ -z "$VCSH_REPO_NAME" ] && fatal "$VCSH_COMMAND: could not determine repository name" 1
 	export VCSH_REPO_NAME
 	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
-elif [ "$1" = 'version' ]; then
+elif [ "$VCSH_COMMAND" = 'version' ]; then
 	echo "$SELF $VERSION"
+	git version
 	exit
-elif [ "$1" = 'which' ]; then
-	[ -z "$2" ] && fatal "$1: please specify a filename" 1
-	[ -n "$3" ] && fatal "$1: too many parameters" 1
-	export VCSH_COMMAND="$1"
+elif [ "$VCSH_COMMAND" = 'which' ]; then
+	[ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a filename" 1
+	[ -n "$3" ] && fatal "$VCSH_COMMAND: too many parameters" 1
 	export VCSH_COMMAND_PARAMETER="$2"
-elif [ "$1" = 'delete' ]           ||
-     [ "$1" = 'enter' ]            ||
-     [ "$1" = 'init' ]             ||
-     [ "$1" = 'list-tracked-by' ]  ||
-     [ "$1" = 'rename' ]           ||
-     [ "$1" = 'run' ]              ||
-     [ "$1" = 'upgrade' ]          ||
-     [ "$1" = 'write-gitignore' ]; then
-	[ -z $2 ]                      && fatal "$1: please specify repository to work on" 1
-	[ "$1" = 'rename' -a -z "$3" ] && fatal "$1: please specify a target name" 1
-	[ "$1" = 'run'    -a -z "$3" ] && fatal "$1: please specify a command" 1
-	export VCSH_COMMAND="$1"
+elif [ "$VCSH_COMMAND" = 'delete' ]           ||
+     [ "$VCSH_COMMAND" = 'enter' ]            ||
+     [ "$VCSH_COMMAND" = 'init' ]             ||
+     [ "$VCSH_COMMAND" = 'list-tracked-by' ]  ||
+     [ "$VCSH_COMMAND" = 'rename' ]           ||
+     [ "$VCSH_COMMAND" = 'run' ]              ||
+     [ "$VCSH_COMMAND" = 'upgrade' ]          ||
+     [ "$VCSH_COMMAND" = 'write-gitignore' ]; then
+	[ -z $2 ]                                 && fatal "$VCSH_COMMAND: please specify repository to work on" 1
+	[ "$VCSH_COMMAND" = 'rename' -a -z "$3" ] && fatal "$VCSH_COMMAND: please specify a target name" 1
+	[ "$VCSH_COMMAND" = 'run'    -a -z "$3" ] && fatal "$VCSH_COMMAND: please specify a command" 1
 	export VCSH_REPO_NAME="$2"
 	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
 	[ "$VCSH_COMMAND" = 'rename' ] && { export VCSH_REPO_NAME_NEW="$3";
 	                                    export GIT_DIR_NEW="$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git"; }
 	[ "$VCSH_COMMAND" = 'run' ]    && shift 2
-elif [ "$1" = 'list' ] ||
-     [ "$1" = 'list-tracked' ] ||
-     [ "$1" = 'pull' ] ||
-     [ "$1" = 'push' ]; then
-	export VCSH_COMMAND="$1"
+elif [ "$VCSH_COMMAND" = 'commit' ] ||
+     [ "$VCSH_COMMAND" = 'list' ] ||
+     [ "$VCSH_COMMAND" = 'list-tracked' ] ||
+     [ "$VCSH_COMMAND" = 'pull' ] ||
+     [ "$VCSH_COMMAND" = 'push' ]; then
+	:
+elif [ "$VCSH_COMMAND" = 'status' ]; then
+	export VCSH_REPO_NAME="$2"
 elif [ -n "$2" ]; then
 	export VCSH_COMMAND='run'
 	export VCSH_REPO_NAME="$1"
@@ -382,7 +473,7 @@ elif [ -n "$2" ]; then
 	[ -d $GIT_DIR ] || { help; exit 1; }
 	shift 1
 	set -- "git" "$@"
-elif [ -n "$1" ]; then
+elif [ -n "$VCSH_COMMAND" ]; then
 	export VCSH_COMMAND='enter'
 	export VCSH_REPO_NAME="$1"
 	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
@@ -405,7 +496,7 @@ check_dir() {
 		if [ -e "$check_directory" ]; then
 			fatal "'$check_directory' exists but is not a directory" 13
 		else
-			info "attempting to create '$check_directory'"
+			verbose "attempting to create '$check_directory'"
 			mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
 		fi
 	fi
@@ -413,6 +504,7 @@ check_dir() {
 
 check_dir "$VCSH_REPO_D"
 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && check_dir "$VCSH_BASE/.gitignore.d"
+[ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && check_dir "$VCSH_BASE/.gitattributes.d"
 
 verbose "$VCSH_COMMAND begin"
 export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
@@ -420,3 +512,4 @@ hook pre-command
 $VCSH_COMMAND "$@"
 hook post-command
 verbose "$VCSH_COMMAND end, exiting"
+exit $VCSH_COMMAND_RETURN_CODE